import os

import axipy
from axipy import Plugin, Position

from PiketPoints.ui.DlgPiketCreate import DlgPiket
from PiketPoints.ui.addTools.Observer import factoryObserverTabVector


class PluginBuildPikets(Plugin):
    def __init__(self) -> None:
        self.__name_observer="VectorTable"
        self._title = self.tr("Создание точек пикетов")
        self.__observer=factoryObserverTabVector(self.__name_observer)
        local_file_icon = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'icons', 'piket-point-32.png')
        self.__action = self.create_action('Создание точек пикетов',
                                           icon=local_file_icon, on_click=self.run_build_piket,
                                           enable_on=self.__name_observer)
        position = Position('Таблица', 'Действие')
        position.add(self.__action)
    def unload(self):
        self.__action.remove()
    def run_build_piket(self):
        dlg=DlgPiket(axipy.mainwindow.qt_object())
        dlg.exec_()