import axipy
from axipy import ObserverManager, data_manager

def factoryObserverTabSpatialZ(name_observer):
    observer = None
    observer=ObserverManager.get(name_observer)
    if observer is None:
        observer=ObserverManager.create(name_observer,False)



def factoryObserverTabVector(name_observer):
    def isTableVector(obj):
        if not isinstance(obj, axipy.Table):
            return False
        if not obj.is_spatial:
            return False
        try:
            schema_tab = obj.schema
            if schema_tab is None:
                return False
        except:
            return False
        return True
    def existVectorTable(name_table=None):
        count_vector = 0
        for tab in data_manager.tables:
            if tab.name == name_table:
                continue
            if isTableVector(tab):
                count_vector = count_vector + 1
        if count_vector == 0:
            return False
        return True
    observer=None
    try:
        observer=ObserverManager.get(name_observer)
    except:
        pass
    if observer is None:
        observer=ObserverManager.create(name_observer,False)
        def addTable(name_table=None):
            if observer.value:
                return
            table_add=axipy.da.data_manager.find(name_table)
            if isTableVector(table_add):
                observer.value=True
            else:
                observer.value=False

            return

        def removedTable(name_table):
            if not observer.value:
                return
            tab=data_manager.find(name_table)
            is_vector=isTableVector(tab)
            count_tab=data_manager.count
            if is_vector and count_tab==1:
                observer.value=False
                return
            count_vector=0
            for tab in data_manager.tables:
                if tab.name==name_table:
                    continue
                if isTableVector(tab):
                    count_vector=count_vector+1
            if count_vector==0:
                observer.value=False
        def selectCount():
            tabs_for_grid =  axipy.da.data_manager.tables
            count_source=len(tabs_for_grid)
            if count_source<=1:
                observer.setValue(False)
                return
            observer.setValue(True)

            return
        def addChildrenWidget(name_tool,widget):
            observer.children_widgets[name_tool]=widget
        def removeChildrenWidget(name):
            try:
                del observer.children_widgets[name]
            except:
                pass

        setattr(observer, "children_widgets", {})
        setattr(observer, "addTable", addTable)
        setattr(observer, "removedTable", removedTable)
        #setattr(observer, "selectCount", selectCount)

        axipy.da.data_manager.added.connect(observer.addTable)
        axipy.da.data_manager.removed.connect(observer.removedTable)
        #axipy.gui.selection_manager.changed.connect(observer.selectCount)
        observer.value=existVectorTable(None)
    return observer