import math

from axipy import CoordSystem, Point, Pnt, ProgressSpecification, ProgressGuiFlags, AxipyProgressHandler
from axipy import LinearUnits
from PiketPoints.ui.addTools.helperUnit import Distance


def linePikets(start_pnt:Pnt,end_pnt:Pnt,step:float,offset:float,cs:CoordSystem=None):
    base_pnt=start_pnt
    ''' Расстояние и угол между двумя точками '''
    dist, azimuth = Point.distance_by_points(start_pnt, end_pnt, cs)

    #if dist_next_piket<step:
    #    return None,
    if offset>0.0:
        pass

class PointsPiket:

    def __init__(self,ph: AxipyProgressHandler=None):
        self.__progress=ph
        self.__cancel = False
    @property
    def isCancel(self):
        return self.__cancel
    def buildPikets(self,points: list,step:Distance, cs: CoordSystem = None):
        self.__cancel=False
        self.__cs=cs
        self.__step_dist=step
        self.__step=step.to_unit(LinearUnits.m)
        self.__common_dist=0.0
        self.__curent_offset=0.0
        out_pikets_points = []
        count_point = len(points)
        out_pikets_points.append(points[0])
        for i in range(count_point - 1):
            start_pnt = points[i]
            next_point = points[i + 1]
            piket_points=self.linePikets(start_pnt,next_point)
            if piket_points is not None:
                out_pikets_points.extend(piket_points)
                dist, azimuth = Point.distance_by_points(out_pikets_points[-1], next_point, self.__cs)
                self.__curent_offset = dist
        if len(out_pikets_points)==1:
            return None
        return out_pikets_points
    def linePikets(self,start_pnt: Pnt, end_pnt: Pnt):
        piket_points=[]
        ''' Расстояние и угол между двумя точками '''
        dist, azimuth = Point.distance_by_points(start_pnt, end_pnt, self.__cs)
        dist_next_piket=self.__common_dist+self.__step
        if (self.__common_dist+dist)<dist_next_piket:
            return None
        pnt_start=start_pnt
        if self.__curent_offset>0.0:
            dist_next_piket=self.__step-self.__curent_offset
            pnt_start=Point.point_by_azimuth(start_pnt,azimuth,dist_next_piket,self.__cs)
            piket_points.append(pnt_start)
            self.__common_dist=self.__common_dist+self.__step
            self.__curent_offset=0.0
            dist_new=dist-dist_next_piket
            if dist_new<=self.__step:
                if dist_new<self.__step:
                    self.__curent_offset=self.__step-dist_new
                    return piket_points
                if dist_new==self.__step:
                    piket_points.append(end_pnt)
                    self.__common_dist=self.__common_dist + self.__step
                    self.__curent_offset =0
                    return piket_points
            dist=dist_new
        count_piket_in_segment=int(math.trunc(dist/self.__step))
        curent_piket=pnt_start
        for i in range(count_piket_in_segment):
            if self.__progress is not None:
                if self.__progress.is_canceled():
                    self.__cancel=True
                    return None
                self.__progress.add_progress(1)
            curent_piket=Point.point_by_azimuth(curent_piket,azimuth,self.__step,self.__cs)
            dist_temp, azimuth = Point.distance_by_points(curent_piket, end_pnt, self.__cs)
            piket_points.append(curent_piket)
            self.__common_dist=self.__common_dist+self.__step
        return piket_points




